/***************************************************************************
                          main.cpp  -  description
                             -------------------
    begin                : tor jan  2 19:59:03 CET 2003
    copyright            : (C) 2003 by rn E. Hansen
    email                : orn.hansen@swipnet.se
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <kapp.h>
#include <kcmdlineargs.h>
#include <kaboutdata.h>
#include <klocale.h>

#include "touchtyperapp.h"

#include <X11/Xlib.h>
#include <X11/keysym.h>

static const char *description =
	I18N_NOOP("TouchTyper helps train finger layout on a keyboard.");
	
	
static KCmdLineOptions options[] =
{
  { 0, 0, 0 }
  // INSERT YOUR COMMANDLINE OPTIONS HERE
};

int main(int argc, char *argv[])
{

  KAboutData aboutData( "touchtyper", I18N_NOOP("TouchTyper"),
    VERSION, description, KAboutData::License_GPL,
    "(c) 2003, rn E. Hansen", 0, 0, "orn.hansen@swipnet.se");
  aboutData.addAuthor("rn E. Hansen",0, "orn.hansen@swipnet.se");
  KCmdLineArgs::init( argc, argv, &aboutData );
  KCmdLineArgs::addCmdLineOptions( options ); // Add our own options.

  KApplication app;

  if( app.isRestored() ) {
    RESTORE(TouchTyperApp);
  } else {
    TouchTyperApp *touchtyperapp = new TouchTyperApp(0,"touchtype");
    touchtyperapp->show();
  }

  return app.exec();
}

/**
  * The following routines must unfortunately be defined globally
  * as Qt and Xlib include files, don't cooperate that well.
  */
unsigned char
getXKeysym(Display *d,unsigned int xkc,int state=0)
{
  KeySym xks;

  if( xkc == 0 )
    return '\0';
  xks = XKeycodeToKeysym( d,xkc,(state?1:0) );
  if( xks&0xf000 )
    return '';
  return xks&0xff;
}

bool
isXKeyCode(Display *d,unsigned char ascii,unsigned int xks)
{
  if( XKeycodeToKeysym( d,xks,0 ) != XK_VoidSymbol )
    return true;
  if( XKeycodeToKeysym( d,xks,1 ) != XK_VoidSymbol )
    return true;
  if( XKeycodeToKeysym( d,xks,2 ) != XK_VoidSymbol )
    return true;
  return false;
}

