/***************************************************************************
                          touchtyperapp.h  -  description
                             -------------------
    begin                : sn jan 12 2003
    copyright            : (C) 2003 by rn E. Hansen
    email                : orn.hansen@swipnet.se
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef TOUCHTYPERAPP_H
#define TOUCHTYPERAPP_H

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <kapp.h>
#include <kmainwindow.h>
#include <kaccel.h>
#include <kaction.h>
#include <kurl.h>

class TouchTyper;
class QPrinter;

/**
  *@author rn E. Hansen
  */

class TouchTyperApp : public KMainWindow  {
Q_OBJECT
public: 
	TouchTyperApp(QWidget *w=0,const char *n=0);
	~TouchTyperApp();
private: // Private attributes
  KConfig* config;
  KAction* fileNewWindow;
  KAction* fileNew;
  KAction* fileOpen;
  KRecentFilesAction* fileOpenRecent;
  KAction* fileSave;
  KAction* fileSaveAs;
  KAction* fileClose;
  KAction* filePrint;
  KAction* fileQuit;
  KAction* editCut;
  KAction* editCopy;
  KAction* editPaste;
  KAction* editProperties;
  KToggleAction* viewToolBar;
  KToggleAction* viewStatusBar;
  /** The actual view widget, is a trainer.  */
  TouchTyper* view;
  /** Printer used for printing  */
  QPrinter* printer;
protected: // Protected methods
  /** Initialize the menubar actions. */
  void initActions();
  /** Read properties, for application. */
  virtual void readProperties(KConfig *_cfg);
  /** Save property settings, for the current exercise. */
  virtual void saveProperties(KConfig *_cfg);
  /** No descriptions */
  virtual void readOptions();
  /** No descriptions */
  virtual void saveOptions();
  /** Initialize status bar layout. */
  void initStatusBar();
  /** Query if application may exit. */
  bool queryExit();
  /** Query if exercise can be closed. */
  bool queryClose();
public slots: // Public slots
  /** Start a new exercise. */
  void slotFileNew();
  /** No descriptions */
  void slotViewStatusBar();
  /** No descriptions */
  void slotViewToolBar();
  /** Quit the application. */
  void slotFileQuit();
  /** Print the current exercise data. */
  void slotFilePrint();
  /** Open up a new exercise file, to type after. */
  void slotFileOpen();
  /** Save current exercise data, under a new filename. */
  void slotFileSaveAs();
  /** Save the current exercise data. */
  void slotFileSave();
  /** No descriptions */
  void slotStatusMsg(const QString&);
private: // Private methods
  /** Print the exercise data. */
  void printFooter(QPainter&,int,int,int,int);
};

#endif
