/***************************************************************************
                          trainingcourse  -  description
                             -------------------
    begin                : ons feb 11 2004
    copyright            : (C) 2004 by rn E. Hansen
    email                : orn.hansen@swipnet.se
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#include "trainingcourse.h"

#include <qfile.h>

TrainingCourse::TrainingCourse()
 : mDocument("touchtyper")
{
}

TrainingCourse::~TrainingCourse()
{
}

QString TrainingCourse::nextLevel(const QString& pCurrentLevel)
{
	QString level="9999", currentNum = QString::null, s, name = QString::null;
	QDomNodeList nodeList = mDocument.elementsByTagName( "level" );
	QDomElement elem;
	int i=0;
	
	for( ;i < nodeList.count() && currentNum == QString::null;i++ )
		if( pCurrentLevel == nodeList.item(i).toElement().attribute("name") )
			currentNum = nodeList.item(i).toElement().attribute("number");
	for( i=0;i < nodeList.count();i++ )
	{
		elem = nodeList.item(i).toElement();
		s = elem.attribute("number","0");
		if( s.toInt() > currentNum.toInt() && s.toInt() < level.toInt())
		{
			level = s;
			name  = elem.attribute("name");
		}
	}
	return name;
}

/*!
		\fn TrainingCourse::init(const QString&)
 */
void TrainingCourse::init(const QString& pFile)
{
	QFile fil(pFile);
	
	if( fil.open(IO_ReadOnly) )
	{
		mDocument.setContent( &fil );
		fil.close();
	}
	qDebug("course loaded");
}

/*!
    \fn TrainingCourse::nextExercize(const UserExercize)
 */
void TrainingCourse::nextExercize(UserExercize& pCurrent)
{
	QDomElement selected;
	QDomElement elem;
	QDomNodeList nodeList = mDocument.elementsByTagName( pCurrent.level() );
	int i=0;
			
	qDebug("advancing exercize");
	while( i < nodeList.count() )
	{
		elem = nodeList.item(i).toElement();
		if( elem.attribute("number","-1").toInt() > pCurrent.exercizeNumber().toInt()  )
			if( selected.attribute("number","9999").toInt() >= elem.attribute("number","-1").toInt() )
				selected = elem;
		i++;
	}
	pCurrent.init( selected );
}

/*!
		\fn TrainingCourse::getExercize(const QString&,const QString&)
 */
QDomElement TrainingCourse::getExercize(const QString& pLevel, const QString& pExercize)
{
	QDomElement selected;
	QDomNodeList nodeList = mDocument.elementsByTagName( pLevel );
	QDomElement elem;
	int i=0;
	
	while( selected.isNull() && i < nodeList.count() )
	{
		elem = nodeList.item(i).toElement();
		if( pExercize == elem.attribute("number","") )
			selected = elem;
		i++;
	}
	return selected;
}
