/***************************************************************************
                          userexercize  -  description
                             -------------------
    begin                : sn jan 4 2004
    copyright            : (C) 2004 by rn E. Hansen
    email                : orn.hansen@swipnet.se
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <qdom.h>

#include "userexercize.h"

UserExercize::UserExercize()
{
	init();
}

UserExercize::UserExercize(QDomElement &pElem)
{
	init(pElem);
}

UserExercize::~UserExercize()
{
}

/*!
    \fn UserExercize::exercize()
 */
QString UserExercize::exercize()
{
    return mExercizeText;
}


/*!
    \fn UserExercize::validTime(int)
 */
bool UserExercize::accept(int pTime, int pErrors)
{
	qDebug("(%d,%d)",pTime,pErrors);
	qDebug("(%d,%d,%d)",mMinTime,mMaxTime,mMaxErrors);
  return (pTime>=mMinTime) && (pTime<=mMaxTime) && (pErrors<=mMaxErrors);
}


/*!
    \fn UserExercize::init()
 */
void UserExercize::init()
{
	mExercizeLevel	= "beginner";
	mExercizeText		= QString::null;
	mExercizeNumber	= "0";
	mMaxErrors			= 0;
	mMaxTime				= 1*60;
	mMinTime				= 1*60;
}


/*!
    \fn UserExercize::exercizeNumber()
 */
QString UserExercize::exercizeNumber() const
{
	return mExercizeNumber;
}


/*!
    \fn UserExercize::level()
 */
QString UserExercize::level() const
{
	return mExercizeLevel;
}


/*!
    \fn UserExercize::init(QDomElement&)
 */
void UserExercize::init(QDomElement& pElem)
{
	mExercizeText		= pElem.text();
	mExercizeNumber	= pElem.attribute("number","0");
	mMaxErrors			= pElem.attribute("errors","0").toInt();
	mMaxTime				= pElem.attribute("max","60").toInt();
	mMinTime				= pElem.attribute("min","60").toInt();
}


/*!
    \fn UserExercize::advanceLevel(const QString&)
 */
void UserExercize::advanceLevel(const QString& pLevel)
{
	init();
	mExercizeLevel	= pLevel;
}
